## iOS Testing/Automation Best Practice 



#### WWDC Reference 

* Testing in XCode 5 (@2013)
* Continuous Integration with Xcode 5 (@2013)
* Advanced Debugging with LLDB (@2013)
* Debugging with Xcode (@2013)
* OS X Automation Update (@2013)
* Secure Automation Techniques in OS X (@2012)
* Lion-Sized Automation (@2011)
* **Combining Web Accessibility and Automation on iOS** (@2011)
* Testing Your Location-Aware App Without Leaving Your Chair (@2011)
* **Automating User Interface Testing with Instruments** (@2010)
* Automating the Creation of iPad Content (@2010)


#### Apple Doc Ref

* [Instruments User Guide](https://developer.apple.com/library/ios/documentation/DeveloperTools/Conceptual/InstrumentsUserGuide/Introduction/Introduction.html#//apple_ref/doc/uid/TP40004652)
    - [Automating UI Testing](https://developer.apple.com/library/ios/documentation/DeveloperTools/Conceptual/InstrumentsUserGuide/UsingtheAutomationInstrument/UsingtheAutomationInstrument.html#//apple_ref/doc/uid/TP40004652-CH20-SW1)  
* [Xcode Continuous Integration Guide](https://developer.apple.com/library/ios/documentation/IDEs/Conceptual/xcode_guide-continuous_integration/000-About_Continuous_Integration/about_continuous_integration.html)
* [UI Automation JavaScript Reference](https://developer.apple.com/library/ios/documentation/DeveloperTools/Reference/UIAutomationRef/_index.html)
* [Instruments User Reference](https://developer.apple.com/library/ios/documentation/AnalysisTools/Reference/Instruments_User_Reference/Introduction/Introduction.html)


#### 3rd Reference 
*  [**Zucchini** - A visual iOS testing framework that loves your apps](http://www.zucchiniframework.org/)
      - [Automated iOS Testing with Zucchini](http://www.jacopretorius.net/2013/04/automated-ios-testing-with-zucchini.html)
*  [Test iOS Apps with UI Automation: Bug Hunting Made Easy](http://pragprog.com/book/jptios/test-ios-apps-with-ui-automation)
*  [TuneUp.JS](http://www.tuneupjs.org/)
*  [Keep It Functional (KIF)](https://github.com/kif-framework/KIF)
*  [WaxSim - iOS Simulator in CLI](https://github.com/jonathanpenn/WaxSim)
*  [TestStack](http://teststack.net/)
      - [Seleno (Automated UI Test)](http://docs.teststack.net/seleno/index.html)
*  [Testing with Frank](http://www.testingwithfrank.com/)


#### Other Reference 

* <http://acornheroes.com/2010/08/setting-up-an-automated-build-in-an-ios-environment/>
* <http://www.fastcolabs.com/3012626/open-company/finally-three-ways-to-automate-ios-app-testing>
* [List of GUI Testing Tools](https://en.wikipedia.org/wiki/List_of_GUI_testing_tools)
* <http://blog.manbolo.com/2012/04/08/ios-automated-tests-with-uiautomation>
* [Automated UI Testing Done Right](http://www.mehdi-khalili.com/presentations/automated-ui-testing-done-right-at-dddsydney)
* <https://www.cocoacontrols.com/posts/introduction-to-uiautomation-apple-s-automated-ui-testing-framework>
* <http://www.stewgleadow.com/blog/2011/10/26/which-automated-ios-testing-tool-to-use/>
* 





